//////////////////////////////////////////////////////////////////////////
//	"perflib.h"
//------------------------------------------------------------------------
//	$Id: perflib.h 162 2006-02-25 12:25:15Z taro $
//////////////////////////////////////////////////////////////////////////
#ifndef	PERFLIB_H_INCLUDED
#define	PERFLIB_H_INCLUDED

#include	<windows.h>
#include	<tchar.h>
#include	<pdh.h>
#include	<pdhmsg.h>

class	PerfLib;

class	PerfLib
{
public:
	class	CounterWork
	{
	friend class	PerfLib;
	private:
		CounterWork	*next, *prev;
		BOOL		enableCounter;
		HCOUNTER	hCounter;
		TCHAR *		path;
	public:
		CounterWork();
		~CounterWork();
	};
	typedef CounterWork *	Counter;

private:
	BOOL				openQuery;
	HQUERY				hQuery;
	unsigned			numCounter;
	Counter				counterList;
	TCHAR				*msgbuf;

public:
	PDH_STATUS			pdhstt;

private:
	void		add_counter(PerfLib::Counter counter);
	void		del_counter(PerfLib::Counter counter);

public:
	PerfLib();
	virtual ~PerfLib();

	int					OpenQuery(void);
	void				CloseQuery(void);
	PerfLib::Counter	AddCounter(const TCHAR * path, void * userdata);
	PerfLib::Counter	AddCounter(PDH_COUNTER_PATH_ELEMENTS & ele, void * userdata);
	int					RemoveCounter(PerfLib::Counter counter);

	int		CalculateCounterFromRawValue(DWORD format, PDH_RAW_COUNTER * rawValue1, PDH_RAW_COUNTER * rawValue2, PDH_FMT_COUNTERVALUE * fmtValue);
	int		CollectQueryData(void);
	int		GetFormattedCounterValue(PerfLib::Counter counter, DWORD format, DWORD * type, PDH_FMT_COUNTERVALUE * value);
	int		GetRawCounterValue(PerfLib::Counter counter, DWORD * type, PDH_RAW_COUNTER *rawcounter);

	const TCHAR *	GetErrMsg(DWORD stt);
	const TCHAR *	GetErrMsg(void) { return this->GetErrMsg(this->pdhstt); }
};

#endif
