//////////////////////////////////////////////////////////////////////////
//	"atahead.h"
//------------------------------------------------------------------------
//	$Id: atahead.h 163 2006-02-25 12:25:23Z taro $
//////////////////////////////////////////////////////////////////////////
#ifndef	ATAHEAD_H_INCLUDED
#define	ATAHEAD_H_INCLUDED

#if	defined(LINUX)
#	include	"../linux/defs.h"
#endif
#if	defined(WIN32)
#	include	<windows.h>
#endif
#if	!defined(ATTB_PACKED)
# if	defined(LINUX)
#   define	ATTB_PACKED	__attribute ((packed))
# endif
# if	defined(WIN32)
#   define	ATTB_PACKED
# endif
#endif

	enum	AtaCommandReg
	{
		ATA_IDENTIFY_DEVICE             = 0xEC,
		ATA_IDENTIFY_PACKET_DEVICE      = 0xA1,
		ATA_SMART_CMD                   = 0xB0,
		ATA_CHECK_POWER_MODE            = 0xE5,
	};
	enum	AtaSmartFeature
	{
		ATA_SMART_READ_VALUES           = 0xD0,
		ATA_SMART_READ_THRESHOLDS       = 0xD1,
	};
#if	defined(_MSC_VER)
#	pragma pack(push,1)
#endif

	struct ATA_WORD
	{
		BYTE	b[2];
		unsigned	GetData(void) { return this->b[0] | (this->b[1]<<8); }
	};

	struct AtaIdentifyDevice
	{
		ATA_WORD	device_classificaion;					// +000 (word offset)
		ATA_WORD	cylinder_trasnrate_mode;				// +001
		ATA_WORD	content_37C8H;							// +002
		ATA_WORD	head_trasnrate_mode;					// +003
		ATA_WORD	rsv003[2];								// +004
		ATA_WORD	sector_per_track_transrate_mode;		// +006
		ATA_WORD	sector_gap_bytes;						// +007
		ATA_WORD	sync_fields_bytes;						// +008
		ATA_WORD	rsb009;									// +009
		ATA_WORD	serial_number[10];						// +010
		ATA_WORD	controller_type;						// +020
		ATA_WORD	buffer_size;							// +021
		ATA_WORD	ECC_bytes;								// +022
		ATA_WORD	micro_code_version[4];					// +023
		ATA_WORD	model_number[20];						// +027
		ATA_WORD	content_8010H;							// +047
		ATA_WORD	rsv048;									// +048
		ATA_WORD	capabilities049;						// +049
		ATA_WORD	capabilities050;						// +050
		ATA_WORD	PIO_data_trasnfer_cycle_timing_mode;	// +051
		ATA_WORD	DMA_data_trasnfer_cycle_timing_mode;	// +052
		ATA_WORD	validity_flag;							// +053	
		ATA_WORD	current_cylinders;						// +054
		ATA_WORD	current_heads;							// +055
		ATA_WORD	current_sectors_per_track;				// +056
		ATA_WORD	current_capacity[2];					// +057-058
		ATA_WORD	current_multiple_setting;				// +059
		ATA_WORD	total_user_address_sectors[2];			// +060-061
		ATA_WORD	rsb062;									// +062
		ATA_WORD	multiword_DMA_trasnfer_capability;		// +063
		ATA_WORD	flow_control_PIO_trasfer_modes_supported;						// +064
		ATA_WORD	min_multiword_DMA_transfer_cycle_time_per_word;					// +065
		ATA_WORD	manufacturers_recommended_multiword_DMA_transfer_cycle_time;	// +066
		ATA_WORD	min_PIO_transfer_cycle_tim_without_flow_control;				// +067
		ATA_WORD	min_PIO_transfer_cycle_time_with_IORDY_flow_control;			// +068
		ATA_WORD	rsb069[6];								// +069-074
		ATA_WORD	queue_depth;							// +075
		ATA_WORD	rsb076[4];								// +076-079
		ATA_WORD	major_versopn_number;					// +080
		ATA_WORD	minor_version_number;					// +081
		ATA_WORD	command_set082;							// +082
		ATA_WORD	command_set083;							// +083
		ATA_WORD	command_set_extension;					// +084
		ATA_WORD	command_set_enable;						// +085
		ATA_WORD	command_set086;							// +086
		ATA_WORD	command_set087;							// +087
		ATA_WORD	ultra_DMA_trasnfer_mode;								// +088
		ATA_WORD	time_required_for_security_erase_unit_completion;		// +089
		ATA_WORD	time_required_for_enhanced_security_erase_completion;	// +090
		ATA_WORD	current_advanced_power_management_value;				// +091
		ATA_WORD	master_password_revision_code;							// +092
		ATA_WORD	hardware_reset_result;									// +093
		ATA_WORD	current_advanced_acoustic_management_value;				// +094
		ATA_WORD	rsb095[5];								// +095-099
		ATA_WORD	min_user_LBA_address_48bit[4];			// +100-103
		ATA_WORD	rsb104[23];								// +104-126
		ATA_WORD	removable_media_status_notification;	// +127
		ATA_WORD	security_mode;							// +128
		ATA_WORD	current_option;							// +129
		ATA_WORD	rsb130[30];								// +130-159
		ATA_WORD	rsb160[95];								// +160-254
		ATA_WORD	checksum;								// +255
	} ATTTB_PACKED;

	struct AtaSmartAttribute
	{
		BYTE			id;
		BYTE			flags[2];
		BYTE			value;
		BYTE			worst;
		BYTE			raw[6];
		BYTE			rsv;
	} ATTB_PACKED;

	enum	AtaSmartEnum
	{
		NUMBER_ATA_SMART_ATTRIBUTES     = 30,
	};

	struct AtaSmartValues
	{
		BYTE				data_structure_revision_number[2];					// +000 
		AtaSmartAttribute	device_attribute[NUMBER_ATA_SMART_ATTRIBUTES];		// +002            : 12 * 30 = 360
		BYTE				offline_data_collection_status;						// +362     (0x16A
		BYTE				self_test_execution_status;							// +363     (0x16B
		BYTE				total_time_in_seconds_to_complete_offline_data_collection_activity[2];	// +364 (0x16C
		BYTE				current_segment_pointer;							// +366     (0x16E
		BYTE				offline_data_collection_capability;					// +367     (0x16F
		BYTE				smart_capability[2];								// +368-369 (0x170-171
		BYTE				smart_device_error_logging_capability;				// +370     (0x172
		BYTE				selftest_failure_check_point;						// +371     (0x173
		BYTE				short_self_test_completion_time_in_minutes;			// +372     (0x174
		BYTE				extended_self_test_completion_time_in_minutes;		// +373     (0x175
		BYTE				rsv176[12];											// +374     (0x176
		BYTE				vendor_specific[125];								// +386     (0x182
		BYTE				chksum;												// +511     (0x1FF
	} ATTR_PACKED; 

	struct AtaSmartThresholdAttribute
	{
		BYTE	id;
		BYTE	threshold;
		BYTE	rsv[10];
	} ATTB_PACKED;

	struct AtaSmartThresholds
	{
		BYTE						data_structure_revision_number[2];					// +000
		AtaSmartThresholdAttribute	threshhold_attribute[NUMBER_ATA_SMART_ATTRIBUTES];	// +002 
		BYTE						rsb362[149];										// +362 (0x16A
		BYTE						chksum;												// +511 (0x1FF
	} ATTB_PACKED;

#if	defined(_MSC_VER)
#	pragma pack(pop)
#endif

#endif
